; Setmouse.Asm
; Assembly source for DB4 v1.5 BIN to enable/disable mouse
;
; To create BIN:
;
; QASM Setmouse.asm
; LINK Setmouse.obj
; EXE2BIN Setmouse.exe
;
; To use:
;
; LOAD Setmouse
; lMouse = CALL("Setmouse",.F.)  && turn off mouse cursor
; lMouse = CALL("Setmouse",.T.)  && turn on mouse cursor
; Returns: 'F' if no mouse driver detected, 'T' if detected

        .MODEL TINY, PASCAL
        .CODE
        ORG 0
MAIN    PROC    FAR
        JMP     SHORT EGOEND
        DB      13,10,'SETMOUSE.BIN - Bowen Moursund',13,10,26
EGOEND:
        CMP     CX, 0                   ; quit if no parm
        JE      DONE

        PUSH    BX                      ; save parm pointer

        MOV     AX, 21h                 ; is there a mouse?
        INT     33h                     ; mouse interrupt
        CMP     AX, 33                  ; No mouse?
        JE      SHORT NOMOUSE           ; no mouse, jump

        POP     BX                      ; restore parm pointer
        CMP     BYTE PTR [BX], 'F'      ; mouse cursor off?
        JNE     SHORT ON                ; no, jump to ON
        JMP     SHORT OFF               ; else jump to OFF
ON:
        PUSH    BX                      ; save parm pointer
        MOV     AX,1                    ; unhide function
        INT     33h                     ; mouse interrupt
        MOV     AX, 20h                 ; enable function
        INT     33h                     ; mouse interrupt
        JMP     SHORT YESMOUSE
OFF:
        PUSH    BX                      ; save parm pointer
        MOV     AX,2                    ; hide function
        INT     33h                     ; mouse interrupt
        MOV     AX, 1Fh                 ; disable function
        INT     33h                     ; mouse interrupt
YESMOUSE:
        POP     BX                      ; restore parm pointer
        MOV     BYTE PTR [BX], 'T'      ; yes, mouse, return .T.
        JMP     SHORT DONE
NOMOUSE:
        POP     BX                      ; restore parm pointer
        MOV     BYTE PTR [BX], 'F'      ; no mouse, return .F.
DONE:
        RET
MAIN    ENDP
        END
